#!/bin/sh
#
# chkconfig: 345 90 10
# description: Consul agent
# processname: consul

# Source function library.
[[ -f /etc/rc.d/init.d/functions ]] && . /etc/rc.d/init.d/functions

exec="/usr/local/sbin/consul"
prog="consul"
user="{{ consul_user }}"
pidfile="/var/run/${prog}.pid"
lockfile="/var/lock/subsys/${prog}"
logfile="/dev/null"
sysconfig="/etc/sysconfig/$prog"

[[ -f $sysconfig ]] && . $sysconfig

export GOMAXPROCS=${GOMAXPROCS:-2}
cmd="$exec agent -config-dir={{ consul_config_dir }} &>> $logfile"

start() {
    echo -n $"Starting $prog: "
    touch $logfile $pidfile
    chown $user:$user $logfile $pidfile
    daemon --check=$prog --pidfile=$pidfile --user=$user "{ $cmd & } ; echo \$! >| $pidfile"
    retval=$?
    [ $retval -eq 0 ] && touch $lockfile
    echo
    return $retval
}

stop() {
    echo -n $"Stopping $prog: "
    killproc -p $pidfile $exec
    retval=$?
    [ $retval -eq 0 ] && rm -f $lockfile
    echo
    return $retval
}

restart() {
    stop
    start
}

rh_status() {
    status -p "$pidfile" -l $prog $exec
}

rh_status_q() {
    rh_status >/dev/null 2>&1
}

reload() {
    echo -n $"Reloading $prog: "
    killproc -p $pidfile $exec -HUP
    echo
}

force_reload() {
    restart
}

case "$1" in
    start)
        rh_status_q && exit 0
        $1
        ;;
    stop)
        rh_status_q || exit 0
        $1
        ;;
    status)
        rh_status
        ;;
    restart)
        $1
        ;;
    reload)
        rh_status_q || exit 7
        $1
        ;;
    force-reload)
        force_reload
        ;;
    condrestart|try-restart)
        rh_status_q || exit 0
        restart
        ;;
    *)
    echo "Usage: $0 {start|stop|status|restart|condrestart|try-restart|reload|force-reload}"
    exit 2
esac

exit $?
